Subject: can SFQ and perturb break paquet ordering ?

From: Julien Vehent <[email-masked]>
Date: Wed, 10 Mar 2010 13:22:50 +0100

Hi netdev folks,

I was digging into the sch_sfq code and I was wondering the following (I
assume it's nothing new, I'm just trying to get it right):

Let's consider one UDP connection that has two packets. Packet#1 goes to
bucket#1, then perturb modifies the hashing algorithms and thus Packet#2
goes to bucket#800.

If the round robin was positionned after bucket#1 but before bucket#800
when perturb occured, then Packet#2 will be sent before Packet#1. And since
UDP can't reordered, it will be processed before on the received end.

Am I getting this right or is there something in the code that I missed ?

Thanks for your help.

Julien Vehent